#include "hello.h"

char *get_namespace(){
        return "xmlns=\"www.abo.fi\"";
}


/**
 * @brief Register ontology.
 *
 * It creates all structures, such as classes and properties. Use it firs in your propgramm.
 */
void register_ontology()
{
    list_t *tmp_node = NULL;

#if INCLUDE_PROPERTY_ISA

PROPERTY_ISA =  (property_t *) malloc(sizeof(property_t));
PROPERTY_ISA->name = strdup("isA");
PROPERTY_ISA->about = strdup("http://X#isA");
//PROPERTY_ISA->range = "http://X#World"; //getRange
PROPERTY_ISA->domain = strdup("http://X#Universum");
PROPERTY_ISA->maxcardinality = -1;
PROPERTY_ISA->mincardinality = -1;
PROPERTY_ISA->subpropertyof = NULL;
PROPERTY_ISA->rtti = RTTI_PROPERTY;
PROPERTY_ISA->type = OBJECTPROPERTY;

add_entity_to_repository((void *) PROPERTY_ISA);

#endif
#if INCLUDE_PROPERTY_HAS

PROPERTY_HAS =  (property_t *) malloc(sizeof(property_t));
PROPERTY_HAS->name = strdup("has");
PROPERTY_HAS->about = strdup("http://X#has");
//PROPERTY_HAS->range = "http://www.w3.org/2001/XMLSchema#string"; //getRange
PROPERTY_HAS->domain = strdup("http://X#Universum");
PROPERTY_HAS->maxcardinality = 10;
PROPERTY_HAS->mincardinality = -1;
PROPERTY_HAS->subpropertyof = NULL;
PROPERTY_HAS->rtti = RTTI_PROPERTY;
PROPERTY_HAS->type = DATATYPEPROPERTY;

add_entity_to_repository((void *) PROPERTY_HAS);

#endif




#if INCLUDE_CLASS_UNIVERSUM

CLASS_UNIVERSUM = (class_t *) malloc(sizeof(class_t));
CLASS_UNIVERSUM->rtti = RTTI_CLASS;
CLASS_UNIVERSUM->classtype =  strdup("http://X#Universum");
CLASS_UNIVERSUM->properties = list_get_new_list();
CLASS_UNIVERSUM->instances = NULL;
CLASS_UNIVERSUM->superclasses = list_get_new_list();

add_entity_to_repository((void *) CLASS_UNIVERSUM);

#if INCLUDE_PROPERTY_HAS
tmp_node = list_get_new_node(PROPERTY_HAS);
list_add_node(tmp_node, CLASS_UNIVERSUM->properties);
#endif
#if INCLUDE_PROPERTY_ISA
tmp_node = list_get_new_node(PROPERTY_ISA);
list_add_node(tmp_node, CLASS_UNIVERSUM->properties);
#endif

#endif
#if INCLUDE_CLASS_WORLD

CLASS_WORLD = (class_t *) malloc(sizeof(class_t));
CLASS_WORLD->rtti = RTTI_CLASS;
CLASS_WORLD->classtype =  strdup("http://X#World");
CLASS_WORLD->properties = list_get_new_list();
CLASS_WORLD->instances = NULL;
CLASS_WORLD->superclasses = list_get_new_list();

add_entity_to_repository((void *) CLASS_WORLD);


#endif
#if INCLUDE_CLASS_NOTHING

CLASS_NOTHING = (class_t *) malloc(sizeof(class_t));
CLASS_NOTHING->rtti = RTTI_CLASS;
CLASS_NOTHING->classtype =  strdup("http://www.w3.org/2002/07/owl#Nothing");
CLASS_NOTHING->properties = list_get_new_list();
CLASS_NOTHING->instances = NULL;
CLASS_NOTHING->superclasses = list_get_new_list();

add_entity_to_repository((void *) CLASS_NOTHING);

#if INCLUDE_PROPERTY_HAS
tmp_node = list_get_new_node(PROPERTY_HAS);
list_add_node(tmp_node, CLASS_NOTHING->properties);
#endif
#if INCLUDE_PROPERTY_ISA
tmp_node = list_get_new_node(PROPERTY_ISA);
list_add_node(tmp_node, CLASS_NOTHING->properties);
#endif

#endif
#if INCLUDE_CLASS_THING

CLASS_THING = (class_t *) malloc(sizeof(class_t));
CLASS_THING->rtti = RTTI_CLASS;
CLASS_THING->classtype =  strdup("http://www.w3.org/2002/07/owl#Thing");
CLASS_THING->properties = list_get_new_list();
CLASS_THING->instances = NULL;
CLASS_THING->superclasses = list_get_new_list();

add_entity_to_repository((void *) CLASS_THING);


#endif


#if INCLUDE_CLASS_UNIVERSUM
#if INCLUDE_CLASS_THING
tmp_node = list_get_new_node(CLASS_THING);
list_add_node(tmp_node, CLASS_UNIVERSUM->superclasses);
#endif
#endif
#if INCLUDE_CLASS_WORLD
#if INCLUDE_CLASS_THING
tmp_node = list_get_new_node(CLASS_THING);
list_add_node(tmp_node, CLASS_WORLD->superclasses);
#endif
#endif
#if INCLUDE_CLASS_NOTHING
#if INCLUDE_CLASS_UNIVERSUM
tmp_node = list_get_new_node(CLASS_UNIVERSUM);
list_add_node(tmp_node, CLASS_NOTHING->superclasses);
#endif
#endif
#if INCLUDE_CLASS_NOTHING
#if INCLUDE_CLASS_WORLD
tmp_node = list_get_new_node(CLASS_WORLD);
list_add_node(tmp_node, CLASS_NOTHING->superclasses);
#endif
#endif



}


